import numpy as np

def forw_AD(u, m, x0, h):

    N = len(u)

    udot = np.zeros(N)
    udot[m] = 1
    xdot = np.zeros(N)

    xk = x0
    xdot[0] = h * udot[0]

    for i in range(1, N):
        xk = xk + h * ((1 - xk) * xk + u[i-1])
        dfdu = h
        dfdx = 1 + h * (1 - 2*xk)
        xdot[i] = dfdu * udot[i] + dfdx * xdot[i-1]

    # m-th column of jacobian
    Jp = xdot

    return Jp
